<!--
 * @Author: zhp
 * @Date: 2023-01-11 09:24:58
 * @LastEditTime: 2023-07-11 15:38:25
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <SearchBar :formConfigs="formConfig" ref="ruleForm" @headBtnClick="buttonClick">
        <!-- <el-badge :value="1" class="item">
          <el-button type="primary" size="small" @click="conditionSearch">条件搜索</el-button>
        </el-badge> -->
      </SearchBar>
      <base-table :table-props="tableProps" :page="listQuery.page" :limit="listQuery.limit" :table-data="tableData">
        <method-btn v-if="tableBtn.length" slot="handleBtn" :width="100" label="操作" :method-list="tableBtn"
          @clickBtn="handleClick" />
      </base-table>
      <pagination :limit.sync="listQuery.limit" :page.sync="listQuery.page" :total="listQuery.total"
        @pagination="getDataList" />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog :dialogTitle="addOrEditTitle" :dialogVisible="addOrUpdateVisible" @cancel="handleCancel"
        @confirm="handleConfirm" :before-close="handleCancel">
        <disposalMethod-add ref="addOrUpdate" @refreshDataList="successSubmit">
        </disposalMethod-add>
        <!-- <el-row slot="footer" type="flex" justify="end"> </el-row> -->
      </base-dialog>
      <!-- <base-dialog :dialogTitle="searchOrEditTitle" :dialogVisible="searchOrUpdateVisible" @cancel="handleSearchCancel"
        @confirm="handleSearchConfirm" :before-close="handleSearchCancel">
        <disposalMethod-search ref="searchOrUpdate" @successSubmit="conditionSearchSubmit"></disposalMethod-search>
        <el-row slot="footer" type="flex" justify="end">
          <el-col :span="12">
            <el-button size="small" type="primary" plain class="btnTextStyle" @click="handleSearchCancel">
              {{ $t("close") }}
            </el-button>
            <el-button size="small" class="btnTextStyle" type="primary" plain @click="handleSearchReset">{{ $t("reset")
              }}</el-button>
            <el-button type="primary" size="small" class="btnTextStyle" @click="handleSearchConfirm">
              {{ $t("search") }}
            </el-button>
          </el-col>
        </el-row>
      </base-dialog> -->
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page"
import disposalMethodAdd from "./components/disposalMethod-add"
// import AddOrUpdate from './params-add-or-update'
import disposalMethodSearch from "./components/disposalMethodSearch"
import available from "./components/available.vue"
import basicSearch from "@/mixins/basic-search"
import i18n from "@/i18n"
const tableProps = [
  {
    prop: 'disposalMethodName',
    label: i18n.t("quality.disposalMethodName"),
    align: 'center'
  },
  {
    prop: 'disposalMethodCode',
    label: i18n.t("quality.disposalMethodCode"),
    align: 'center'
  },
  {
    prop: 'judgmentMark',
    label: i18n.t("quality.judgmentMark"),
    align: 'center'
  },
   {
     prop: 'disposalMethodStatus',
     label: i18n.t("quality.disposalMethodStatus"),
     align: 'center',
     subcomponent: available,
  }
]
const tableBtn = [
  {
    type: "edit",
    btnName: "编辑",
  },
  {
    type: "delete",
    btnName: "删除",
  },
  {
    type: "change",
    btnName: "改变状态",
  },
];
export default {
  mixins: [basicPage],
  components: {
    // disposalMethodSearch,
    disposalMethodAdd
  },
  data() {
    return {
      urlOptions: {
        getDataListURL: "/quality/qmsDisposalMethod/page",
        deleteURL: "/quality/qmsDisposalMethod",
        submitURL: '/quality/qmsDisposalMethod'
      },
      tableProps,
      tableBtn,
      searchOrEditTitle: '',
      searchOrUpdateVisible: false,
      formConfig: [
        {
          type: 'select',
          label: i18n.t('basic.status'),
          placeholder: i18n.t('basic.status'),
          param: 'status',
          selectOptions: [
            {
              id: '0',
              name: '不可用'
            },
            {
              id: '1',
              name: '可用'
            }
          ],
          clearable: true,
          filterable: true
        },
        {
          type: "button",
          btnName: "新增",
          name: "add",
          color: 'success',
          plain: true
          // plain: true,
        },
        {
          type: "button",
          btnName: "搜索",
          name: "search",
          color: "primary",
          // plain: true,
        }
      ],
    };
  },
  // components: {
  //   AddOrUpdate,
  // },
  methods: {
    //search-bar点击
    handleProductCancel() {
      this.productOrUpdateVisible = false;
      this.productOrEditTitle = "";
    },
    // handleSearchCancel() {
    //   this.searchOrEditTitle = "";
    //   this.searchOrUpdateVisible = false;
    // },
    conditionSearch() {
      this.searchOrEditTitle = "搜索";
      this.searchOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.searchOrUpdate.init()
      });
    },
    conditionSearchSubmit(dataForm) {
      this.listQuery.key = dataForm.disposalMethodStatus
      this.listQuery.page = 1;
      this.getDataList();
      this.searchOrUpdateVisible = false;
      // console.log(11111);
      // this.conditionSearchSubmit();
    },
    handleClick(val) {
      console.log(val);
      if (val.type === "delete") {
        this.$confirm(`确定对[名称=${val.data.failureTypeName}]进行删除操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.$http.delete(this.urlOptions.deleteURL, { data: [val.data.id] }).then(({ data }) => {
              if (data && data.code === 0) {
                this.$message({
                  message: "操作成功",
                  type: "success",
                  duration: 1500,
                  onClose: () => {
                    this.getDataList()
                  },
                });
              } else {
                this.$message.error(data.msg);
              }
            });
          })
          .catch(() => { });
      } else if (val.type === 'edit') {
        this.addOrUpdateVisible = true
        this.addOrEditTitle = this.$t('edit')
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(val.data.id);
        })
      } else if (val.type === 'change') {
        let obj = {
          disposalMethodStatus: val.data.disposalMethodStatus === 0 ? 1 : 0,
          id: val.data.id
        }
        this.$http.put(this.urlOptions.submitURL, obj)
          .then(({ data: res }) => {
            if (res.code !== 0) {
              return this.$message.error(res.msg);
            }
            this.$message({
              message: this.$t("prompt.success"),
              type: "success",
              duration: 500,
              onClose: () => {
                console.log(1111)
                this.getDataList()
              },
            });
          })
      }
    },
    buttonClick(val) {
      switch (val.btnName) {
        case "search":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.page = 1;
          this.listQuery.status =val.status ? val.status : null
          this.getDataList();
          break;
        case "add":
          this.addOrEditTitle = this.$t('add')
          this.addOrUpdateVisible = true;
          this.addOrUpdateHandle()
          break;
        default:
          console.log(val)
      }
    },
  }
};
</script>
